// modified heavily from beetle's code
//  to compile on linux:
//    g++ test.cpp -lSDL2 `sdl2-config --cflags --libs` -O2
//
//  to compile on windows:
//    google it
//
//  to compile on mac:
//    dunno, fuc--
//    ok past me, that's enough.
// usage:
// ./<outname> [width] [height] [zoom]
// width and height in px and smaller is more zoomed in for zoom

#include <SDL2/SDL.h>
#include <SDL2/SDL_pixels.h>
#include <SDL2/SDL_render.h>
#include <SDL2/SDL_surface.h>
#include <SDL2/SDL_timer.h>
#include <SDL2/SDL_video.h>
#include <cstdlib>
#include <math.h>
double R;
double i;
double previousR;
double previousI;
int x = 0;
int y = 0;
int itterations = 2;
double hue1 = 1;
int stopper = 0;
double zoom = 2.275;
int sx = 0;
int sy = 0;
int px = 0;
int py = 0; // 2.275 for the mandelbrot set
SDL_Renderer *renderer = NULL;

int displayWidth = 1000;
int displayHeight = 500;

void draw() {
  if (hue1 > 251) {
    stopper = 1;
  }
  if (stopper == 0) {
    // fill(hue1, 0, hue1)
    SDL_SetRenderDrawColor(renderer, hue1, 0, hue1, 255);
  } else {
    // fill(0, 0, 0)
    SDL_SetRenderDrawColor(renderer, 0, 0, 0, 255);
  }
  if (x < (displayWidth)) {
    for (int b = 0; b < 16384; b++) {
      R = (x / (displayHeight / zoom)) -
          (((float)displayWidth / displayHeight) * (zoom / 2));
      i = (y / (displayHeight / zoom)) - (zoom / 2);
      for (int a = 0; a < itterations; a++) {
        previousR = R;
        previousI = i;
        R = (pow(previousR, 2) - pow(previousI, 2)) +
            ((x / (displayHeight / zoom)) -
             (((float)displayWidth / displayHeight) * (zoom / 2)));
        i = (2 * previousR * previousI) +
            ((y / (displayHeight / zoom)) - (zoom / 2));
      }
      if (sqrt((R * R) + (i * i)) < 2) {
        // rect(x, y, 1, 1)
        SDL_RenderDrawPoint(renderer, x, y);
      }
      y += 1;
      if (y > displayHeight) {
        y = 0;
        x += 1;
      }
    }
  } else {
    x = 0;
    y = 0;
    hue1 += 3;
    itterations += 1;
  }
  return;
}

int main(int argc, char *argv[]) {

  // check

  displayWidth = 1000;
  displayHeight = 500;

  if(argc>1){
    int x=atoi(argv[1]);
    displayWidth=x;
  }
  if(argc>2){
    int y=atoi(argv[2]);
    displayHeight=y;
  }
  if(argc>3){
    zoom=atof(argv[3]);
  }

  const int winWidth = displayWidth;
  const int winHeight = displayHeight;

  // init
  if (SDL_Init(SDL_INIT_VIDEO) < 0) {
    printf("SDL could not initialize! SDL_Error: %s\n", SDL_GetError());
  }

  SDL_Window *window = SDL_CreateWindow("Fract", 100, 100, winWidth, winHeight,
                                        SDL_WINDOW_RESIZABLE);

  if (window == NULL) {
    printf("Window could not be created! SDL_Error: %s\n", SDL_GetError());
  } else {
    SDL_Surface *winSurface = SDL_GetWindowSurface(window);

    // SDL_FillRect(winSurface, NULL,
    //              SDL_MapRGB(winSurface->format, 0xFF, 0xFF, 0xFF));

    SDL_UpdateWindowSurface(window);

    renderer = SDL_GetRenderer(window);

    SDL_Texture *swaptex = SDL_CreateTexture(renderer, SDL_PIXELFORMAT_RGBA8888,
                                             SDL_TEXTUREACCESS_TARGET,
                                             displayWidth, displayHeight);

    SDL_Event e;
    bool quit = false;
    while (quit == false) {
      while (SDL_PollEvent(&e)) {
        if (e.type == SDL_QUIT)
          quit = true;
      }
      SDL_SetRenderTarget(renderer, swaptex);
      draw();
      SDL_SetRenderTarget(renderer, NULL);
      SDL_RenderClear(renderer);
      SDL_RenderCopyEx(renderer, swaptex, NULL, NULL, 0, NULL, SDL_FLIP_NONE);
      SDL_RenderPresent(renderer);
    }
  }

  SDL_DestroyWindow(window);

  SDL_Quit();
  return 0;
}
